-
-
Notifications
You must be signed in to change notification settings - Fork 314
/
Copy pathWordLadder.java
121 lines (106 loc) · 3.79 KB
/
WordLadder.java
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
package com.leetcode.graphs;
import javafx.util.Pair;
import java.util.*;
import static org.junit.jupiter.api.Assertions.assertEquals;
/**
* Level: Medium
* Link: https://leetcode.com/problems/word-ladder/
* Description:
* Given two words (beginWord and endWord), and a dictionary's word list, find the length of shortest transformation
* sequence from beginWord to endWord, such that:
* <p>
* Only one letter can be changed at a time. Each transformed word must exist in the word list. Note that beginWord
* is not a transformed word.
* <p>
* Note:
* - Return 0 if there is no such transformation sequence.
* - All words have the same length.
* - All words contain only lowercase alphabetic characters.
* - You may assume no duplicates in the word list.
* - You may assume beginWord and endWord are non-empty and are not the same.
* <p>
* Example 1:
* Input:
* beginWord = "hit",
* endWord = "cog",
* wordList = ["hot","dot","dog","lot","log","cog"]
* <p>
* Output: 5
* <p>
* Explanation: As one shortest transformation is "hit" -> "hot" -> "dot" -> "dog" -> "cog",
* return its length 5.
* <p>
* Example 2:
* Input:
* beginWord = "hit"
* endWord = "cog"
* wordList = ["hot","dot","dog","lot","log"]
* <p>
* Output: 0
* <p>
* Explanation: The endWord "cog" is not in wordList, therefore no possible transformation.
*
* @author rampatra
* @since 2019-08-15
*/
public class WordLadder {
/**
* Runtime: <a href="https://leetcode.com/submissions/detail/251960230/">79 ms</a>.
*
* @param beginWord
* @param endWord
* @param wordList
* @return
*/
public static int ladderLength(String beginWord, String endWord, List<String> wordList) {
int L = beginWord.length();
Map<String, Set<String>> transformedToOriginalWordMap = new HashMap<>();
Queue<Pair<String, Integer>> queue = new LinkedList<>();
wordList.forEach(word -> {
String transformedWord;
for (int i = 0; i < L; i++) {
transformedWord = word.substring(0, i) + "*" + word.substring(i + 1, L);
transformedToOriginalWordMap.putIfAbsent(transformedWord, new HashSet<>());
transformedToOriginalWordMap.get(transformedWord).add(word);
}
}
);
Set<String> visited = new HashSet<>();
queue.add(new Pair<>(beginWord, 1));
visited.add(beginWord);
while (!queue.isEmpty()) {
Pair<String, Integer> currPair = queue.poll();
String word = currPair.getKey();
Integer level = currPair.getValue();
if (word.equals(endWord)) {
return level;
}
String transformedWord;
for (int i = 0; i < L; i++) {
transformedWord = word.substring(0, i) + "*" + word.substring(i + 1, L);
for (String originalWord : transformedToOriginalWordMap.getOrDefault(transformedWord, Collections.emptySet())) {
if (!visited.contains(originalWord)) {
queue.add(new Pair<>(originalWord, level + 1));
visited.add(originalWord);
}
}
}
}
return 0;
}
/**
* TODO: Optimized both end BFS solution
*
* @param beginWord
* @param endWord
* @param wordList
* @return
*/
public static int ladderLengthOptimized(String beginWord, String endWord, List<String> wordList) {
return -1;
}
public static void main(String[] args) {
assertEquals(5, ladderLength("hit", "cog", Arrays.asList("hot", "dot", "dog", "lot", "log", "cog")));
assertEquals(0, ladderLength("hit", "cog", Arrays.asList("hot", "dot", "dog", "lot", "log")));
}
}